cli.zsh 23 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831
  1. #!/usr/bin/env zsh
  2. function omz {
  3. [[ $# -gt 0 ]] || {
  4. _omz::help
  5. return 1
  6. }
  7. local command="$1"
  8. shift
  9. # Subcommand functions start with _ so that they don't
  10. # appear as completion entries when looking for `omz`
  11. (( ${+functions[_omz::$command]} )) || {
  12. _omz::help
  13. return 1
  14. }
  15. _omz::$command "$@"
  16. }
  17. function _omz {
  18. local -a cmds subcmds
  19. cmds=(
  20. 'changelog:Print the changelog'
  21. 'help:Usage information'
  22. 'plugin:Manage plugins'
  23. 'pr:Manage Oh My Zsh Pull Requests'
  24. 'reload:Reload the current zsh session'
  25. 'theme:Manage themes'
  26. 'update:Update Oh My Zsh'
  27. 'version:Show the version'
  28. )
  29. if (( CURRENT == 2 )); then
  30. _describe 'command' cmds
  31. elif (( CURRENT == 3 )); then
  32. case "$words[2]" in
  33. changelog) local -a refs
  34. refs=("${(@f)$(builtin cd -q "$ZSH"; command git for-each-ref --format="%(refname:short):%(subject)" refs/heads refs/tags)}")
  35. _describe 'command' refs ;;
  36. plugin) subcmds=(
  37. 'disable:Disable plugin(s)'
  38. 'enable:Enable plugin(s)'
  39. 'info:Get plugin information'
  40. 'list:List plugins'
  41. 'load:Load plugin(s)'
  42. )
  43. _describe 'command' subcmds ;;
  44. pr) subcmds=('clean:Delete all Pull Request branches' 'test:Test a Pull Request')
  45. _describe 'command' subcmds ;;
  46. theme) subcmds=('list:List themes' 'set:Set a theme in your .zshrc file' 'use:Load a theme')
  47. _describe 'command' subcmds ;;
  48. esac
  49. elif (( CURRENT == 4 )); then
  50. case "${words[2]}::${words[3]}" in
  51. plugin::(disable|enable|load))
  52. local -aU valid_plugins
  53. if [[ "${words[3]}" = disable ]]; then
  54. # if command is "disable", only offer already enabled plugins
  55. valid_plugins=($plugins)
  56. else
  57. valid_plugins=("$ZSH"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t) "$ZSH_CUSTOM"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t))
  58. # if command is "enable", remove already enabled plugins
  59. [[ "${words[3]}" = enable ]] && valid_plugins=(${valid_plugins:|plugins})
  60. fi
  61. _describe 'plugin' valid_plugins ;;
  62. plugin::info)
  63. local -aU plugins
  64. plugins=("$ZSH"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t) "$ZSH_CUSTOM"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t))
  65. _describe 'plugin' plugins ;;
  66. theme::(set|use))
  67. local -aU themes
  68. themes=("$ZSH"/themes/*.zsh-theme(-.N:t:r) "$ZSH_CUSTOM"/**/*.zsh-theme(-.N:r:gs:"$ZSH_CUSTOM"/themes/:::gs:"$ZSH_CUSTOM"/:::))
  69. _describe 'theme' themes ;;
  70. esac
  71. elif (( CURRENT > 4 )); then
  72. case "${words[2]}::${words[3]}" in
  73. plugin::(enable|disable|load))
  74. local -aU valid_plugins
  75. if [[ "${words[3]}" = disable ]]; then
  76. # if command is "disable", only offer already enabled plugins
  77. valid_plugins=($plugins)
  78. else
  79. valid_plugins=("$ZSH"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t) "$ZSH_CUSTOM"/plugins/*/{_*,*.plugin.zsh}(-.N:h:t))
  80. # if command is "enable", remove already enabled plugins
  81. [[ "${words[3]}" = enable ]] && valid_plugins=(${valid_plugins:|plugins})
  82. fi
  83. # Remove plugins already passed as arguments
  84. # NOTE: $(( CURRENT - 1 )) is the last plugin argument completely passed, i.e. that which
  85. # has a space after them. This is to avoid removing plugins partially passed, which makes
  86. # the completion not add a space after the completed plugin.
  87. local -a args
  88. args=(${words[4,$(( CURRENT - 1))]})
  89. valid_plugins=(${valid_plugins:|args})
  90. _describe 'plugin' valid_plugins ;;
  91. esac
  92. fi
  93. return 0
  94. }
  95. # If run from a script, do not set the completion function
  96. if (( ${+functions[compdef]} )); then
  97. compdef _omz omz
  98. fi
  99. ## Utility functions
  100. function _omz::confirm {
  101. # If question supplied, ask it before reading the answer
  102. # NOTE: uses the logname of the caller function
  103. if [[ -n "$1" ]]; then
  104. _omz::log prompt "$1" "${${functrace[1]#_}%:*}"
  105. fi
  106. # Read one character
  107. read -r -k 1
  108. # If no newline entered, add a newline
  109. if [[ "$REPLY" != $'\n' ]]; then
  110. echo
  111. fi
  112. }
  113. function _omz::log {
  114. # if promptsubst is set, a message with `` or $()
  115. # will be run even if quoted due to `print -P`
  116. setopt localoptions nopromptsubst
  117. # $1 = info|warn|error|debug
  118. # $2 = text
  119. # $3 = (optional) name of the logger
  120. local logtype=$1
  121. local logname=${3:-${${functrace[1]#_}%:*}}
  122. # Don't print anything if debug is not active
  123. if [[ $logtype = debug && -z $_OMZ_DEBUG ]]; then
  124. return
  125. fi
  126. # Choose coloring based on log type
  127. case "$logtype" in
  128. prompt) print -Pn "%S%F{blue}$logname%f%s: $2" ;;
  129. debug) print -P "%F{white}$logname%f: $2" ;;
  130. info) print -P "%F{green}$logname%f: $2" ;;
  131. warn) print -P "%S%F{yellow}$logname%f%s: $2" ;;
  132. error) print -P "%S%F{red}$logname%f%s: $2" ;;
  133. esac >&2
  134. }
  135. ## User-facing commands
  136. function _omz::help {
  137. cat >&2 <<EOF
  138. Usage: omz <command> [options]
  139. Available commands:
  140. help Print this help message
  141. changelog Print the changelog
  142. plugin <command> Manage plugins
  143. pr <command> Manage Oh My Zsh Pull Requests
  144. reload Reload the current zsh session
  145. theme <command> Manage themes
  146. update Update Oh My Zsh
  147. version Show the version
  148. EOF
  149. }
  150. function _omz::changelog {
  151. local version=${1:-HEAD} format=${3:-"--text"}
  152. if (
  153. builtin cd -q "$ZSH"
  154. ! command git show-ref --verify refs/heads/$version && \
  155. ! command git show-ref --verify refs/tags/$version && \
  156. ! command git rev-parse --verify "${version}^{commit}"
  157. ) &>/dev/null; then
  158. cat >&2 <<EOF
  159. Usage: ${(j: :)${(s.::.)0#_}} [version]
  160. NOTE: <version> must be a valid branch, tag or commit.
  161. EOF
  162. return 1
  163. fi
  164. "$ZSH/tools/changelog.sh" "$version" "${2:-}" "$format"
  165. }
  166. function _omz::plugin {
  167. (( $# > 0 && $+functions[$0::$1] )) || {
  168. cat >&2 <<EOF
  169. Usage: ${(j: :)${(s.::.)0#_}} <command> [options]
  170. Available commands:
  171. disable <plugin> Disable plugin(s)
  172. enable <plugin> Enable plugin(s)
  173. info <plugin> Get information of a plugin
  174. list List all available Oh My Zsh plugins
  175. load <plugin> Load plugin(s)
  176. EOF
  177. return 1
  178. }
  179. local command="$1"
  180. shift
  181. $0::$command "$@"
  182. }
  183. function _omz::plugin::disable {
  184. if [[ -z "$1" ]]; then
  185. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <plugin> [...]"
  186. return 1
  187. fi
  188. # Check that plugin is in $plugins
  189. local -a dis_plugins
  190. for plugin in "$@"; do
  191. if [[ ${plugins[(Ie)$plugin]} -eq 0 ]]; then
  192. _omz::log warn "plugin '$plugin' is not enabled."
  193. continue
  194. fi
  195. dis_plugins+=("$plugin")
  196. done
  197. # Exit if there are no enabled plugins to disable
  198. if [[ ${#dis_plugins} -eq 0 ]]; then
  199. return 1
  200. fi
  201. # Remove plugins substitution awk script
  202. local awk_subst_plugins="\
  203. gsub(/[ \t]+(${(j:|:)dis_plugins})/, \"\") # with spaces before
  204. gsub(/(${(j:|:)dis_plugins})[ \t]+/, \"\") # with spaces after
  205. gsub(/\((${(j:|:)dis_plugins})\)/, \"\") # without spaces (only plugin)
  206. "
  207. # Disable plugins awk script
  208. local awk_script="
  209. # if plugins=() is in oneline form, substitute disabled plugins and go to next line
  210. /^[ \t]*plugins=\([^#]+\).*\$/ {
  211. $awk_subst_plugins
  212. print \$0
  213. next
  214. }
  215. # if plugins=() is in multiline form, enable multi flag and disable plugins if they're there
  216. /^[ \t]*plugins=\(/ {
  217. multi=1
  218. $awk_subst_plugins
  219. print \$0
  220. next
  221. }
  222. # if multi flag is enabled and we find a valid closing parenthesis, remove plugins and disable multi flag
  223. multi == 1 && /^[^#]*\)/ {
  224. multi=0
  225. $awk_subst_plugins
  226. print \$0
  227. next
  228. }
  229. multi == 1 && length(\$0) > 0 {
  230. $awk_subst_plugins
  231. if (length(\$0) > 0) print \$0
  232. next
  233. }
  234. { print \$0 }
  235. "
  236. local zdot="${ZDOTDIR:-$HOME}"
  237. local zshrc="${${:-"${zdot}/.zshrc"}:A}"
  238. awk "$awk_script" "$zshrc" > "$zdot/.zshrc.new" \
  239. && command cp -f "$zshrc" "$zdot/.zshrc.bck" \
  240. && command mv -f "$zdot/.zshrc.new" "$zshrc"
  241. # Exit if the new .zshrc file wasn't created correctly
  242. [[ $? -eq 0 ]] || {
  243. local ret=$?
  244. _omz::log error "error disabling plugins."
  245. return $ret
  246. }
  247. # Exit if the new .zshrc file has syntax errors
  248. if ! command zsh -n "$zdot/.zshrc"; then
  249. _omz::log error "broken syntax in '"${zdot/#$HOME/\~}/.zshrc"'. Rolling back changes..."
  250. command mv -f "$zdot/.zshrc.bck" "$zshrc"
  251. return 1
  252. fi
  253. # Restart the zsh session if there were no errors
  254. _omz::log info "plugins disabled: ${(j:, :)dis_plugins}."
  255. # Only reload zsh if run in an interactive session
  256. [[ ! -o interactive ]] || _omz::reload
  257. }
  258. function _omz::plugin::enable {
  259. if [[ -z "$1" ]]; then
  260. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <plugin> [...]"
  261. return 1
  262. fi
  263. # Check that plugin is not in $plugins
  264. local -a add_plugins
  265. for plugin in "$@"; do
  266. if [[ ${plugins[(Ie)$plugin]} -ne 0 ]]; then
  267. _omz::log warn "plugin '$plugin' is already enabled."
  268. continue
  269. fi
  270. add_plugins+=("$plugin")
  271. done
  272. # Exit if there are no plugins to enable
  273. if [[ ${#add_plugins} -eq 0 ]]; then
  274. return 1
  275. fi
  276. # Enable plugins awk script
  277. local awk_script="
  278. # if plugins=() is in oneline form, substitute ) with new plugins and go to the next line
  279. /^[ \t]*plugins=\([^#]+\).*\$/ {
  280. sub(/\)/, \" $add_plugins&\")
  281. print \$0
  282. next
  283. }
  284. # if plugins=() is in multiline form, enable multi flag
  285. /^[ \t]*plugins=\(/ {
  286. multi=1
  287. }
  288. # if multi flag is enabled and we find a valid closing parenthesis,
  289. # add new plugins and disable multi flag
  290. multi == 1 && /^[^#]*\)/ {
  291. multi=0
  292. sub(/\)/, \" $add_plugins&\")
  293. print \$0
  294. next
  295. }
  296. { print \$0 }
  297. "
  298. local zdot="${ZDOTDIR:-$HOME}"
  299. local zshrc="${${:-"${zdot}/.zshrc"}:A}"
  300. awk "$awk_script" "$zshrc" > "$zdot/.zshrc.new" \
  301. && command cp -f "$zshrc" "$zdot/.zshrc.bck" \
  302. && command mv -f "$zdot/.zshrc.new" "$zshrc"
  303. # Exit if the new .zshrc file wasn't created correctly
  304. [[ $? -eq 0 ]] || {
  305. local ret=$?
  306. _omz::log error "error enabling plugins."
  307. return $ret
  308. }
  309. # Exit if the new .zshrc file has syntax errors
  310. if ! command zsh -n "$zdot/.zshrc"; then
  311. _omz::log error "broken syntax in '"${zdot/#$HOME/\~}/.zshrc"'. Rolling back changes..."
  312. command mv -f "$zdot/.zshrc.bck" "$zshrc"
  313. return 1
  314. fi
  315. # Restart the zsh session if there were no errors
  316. _omz::log info "plugins enabled: ${(j:, :)add_plugins}."
  317. # Only reload zsh if run in an interactive session
  318. [[ ! -o interactive ]] || _omz::reload
  319. }
  320. function _omz::plugin::info {
  321. if [[ -z "$1" ]]; then
  322. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <plugin>"
  323. return 1
  324. fi
  325. local readme
  326. for readme in "$ZSH_CUSTOM/plugins/$1/README.md" "$ZSH/plugins/$1/README.md"; do
  327. if [[ -f "$readme" ]]; then
  328. (( ${+commands[less]} )) && less "$readme" || cat "$readme"
  329. return 0
  330. fi
  331. done
  332. if [[ -d "$ZSH_CUSTOM/plugins/$1" || -d "$ZSH/plugins/$1" ]]; then
  333. _omz::log error "the '$1' plugin doesn't have a README file"
  334. else
  335. _omz::log error "'$1' plugin not found"
  336. fi
  337. return 1
  338. }
  339. function _omz::plugin::list {
  340. local -a custom_plugins builtin_plugins
  341. custom_plugins=("$ZSH_CUSTOM"/plugins/*(-/N:t))
  342. builtin_plugins=("$ZSH"/plugins/*(-/N:t))
  343. # If the command is being piped, print all found line by line
  344. if [[ ! -t 1 ]]; then
  345. print -l ${(q-)custom_plugins} ${(q-)builtin_plugins}
  346. return
  347. fi
  348. if (( ${#custom_plugins} )); then
  349. print -P "%U%BCustom plugins%b%u:"
  350. print -lac ${(q-)custom_plugins}
  351. fi
  352. if (( ${#builtin_plugins} )); then
  353. (( ${#custom_plugins} )) && echo # add a line of separation
  354. print -P "%U%BBuilt-in plugins%b%u:"
  355. print -lac ${(q-)builtin_plugins}
  356. fi
  357. }
  358. function _omz::plugin::load {
  359. if [[ -z "$1" ]]; then
  360. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <plugin> [...]"
  361. return 1
  362. fi
  363. local plugin base has_completion=0
  364. for plugin in "$@"; do
  365. if [[ -d "$ZSH_CUSTOM/plugins/$plugin" ]]; then
  366. base="$ZSH_CUSTOM/plugins/$plugin"
  367. elif [[ -d "$ZSH/plugins/$plugin" ]]; then
  368. base="$ZSH/plugins/$plugin"
  369. else
  370. _omz::log warn "plugin '$plugin' not found"
  371. continue
  372. fi
  373. # Check if its a valid plugin
  374. if [[ ! -f "$base/_$plugin" && ! -f "$base/$plugin.plugin.zsh" ]]; then
  375. _omz::log warn "'$plugin' is not a valid plugin"
  376. continue
  377. # It is a valid plugin, add its directory to $fpath unless it is already there
  378. elif (( ! ${fpath[(Ie)$base]} )); then
  379. fpath=("$base" $fpath)
  380. fi
  381. # Check if it has completion to reload compinit
  382. local -a comp_files
  383. comp_files=($base/_*(N))
  384. has_completion=$(( $#comp_files > 0 ))
  385. # Load the plugin
  386. if [[ -f "$base/$plugin.plugin.zsh" ]]; then
  387. source "$base/$plugin.plugin.zsh"
  388. fi
  389. done
  390. # If we have completion, we need to reload the completion
  391. # We pass -D to avoid generating a new dump file, which would overwrite our
  392. # current one for the next session (and we don't want that because we're not
  393. # actually enabling the plugins for the next session).
  394. # Note that we still have to pass -d "$_comp_dumpfile", so that compinit
  395. # doesn't use the default zcompdump location (${ZDOTDIR:-$HOME}/.zcompdump).
  396. if (( has_completion )); then
  397. compinit -D -d "$_comp_dumpfile"
  398. fi
  399. }
  400. function _omz::pr {
  401. (( $# > 0 && $+functions[$0::$1] )) || {
  402. cat >&2 <<EOF
  403. Usage: ${(j: :)${(s.::.)0#_}} <command> [options]
  404. Available commands:
  405. clean Delete all PR branches (ohmyzsh/pull-*)
  406. test <PR_number_or_URL> Fetch PR #NUMBER and rebase against master
  407. EOF
  408. return 1
  409. }
  410. local command="$1"
  411. shift
  412. $0::$command "$@"
  413. }
  414. function _omz::pr::clean {
  415. (
  416. set -e
  417. builtin cd -q "$ZSH"
  418. # Check if there are PR branches
  419. local fmt branches
  420. fmt="%(color:bold blue)%(align:18,right)%(refname:short)%(end)%(color:reset) %(color:dim bold red)%(objectname:short)%(color:reset) %(color:yellow)%(contents:subject)"
  421. branches="$(command git for-each-ref --sort=-committerdate --color --format="$fmt" "refs/heads/ohmyzsh/pull-*")"
  422. # Exit if there are no PR branches
  423. if [[ -z "$branches" ]]; then
  424. _omz::log info "there are no Pull Request branches to remove."
  425. return
  426. fi
  427. # Print found PR branches
  428. echo "$branches\n"
  429. # Confirm before removing the branches
  430. _omz::confirm "do you want remove these Pull Request branches? [Y/n] "
  431. # Only proceed if the answer is a valid yes option
  432. [[ "$REPLY" != [yY$'\n'] ]] && return
  433. _omz::log info "removing all Oh My Zsh Pull Request branches..."
  434. command git branch --list 'ohmyzsh/pull-*' | while read branch; do
  435. command git branch -D "$branch"
  436. done
  437. )
  438. }
  439. function _omz::pr::test {
  440. # Allow $1 to be a URL to the pull request
  441. if [[ "$1" = https://* ]]; then
  442. 1="${1:t}"
  443. fi
  444. # Check the input
  445. if ! [[ -n "$1" && "$1" =~ ^[[:digit:]]+$ ]]; then
  446. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <PR_NUMBER_or_URL>"
  447. return 1
  448. fi
  449. # Save current git HEAD
  450. local branch
  451. branch=$(builtin cd -q "$ZSH"; git symbolic-ref --short HEAD) || {
  452. _omz::log error "error when getting the current git branch. Aborting..."
  453. return 1
  454. }
  455. # Fetch PR onto ohmyzsh/pull-<PR_NUMBER> branch and rebase against master
  456. # If any of these operations fail, undo the changes made
  457. (
  458. set -e
  459. builtin cd -q "$ZSH"
  460. # Get the ohmyzsh git remote
  461. command git remote -v | while read remote url _; do
  462. case "$url" in
  463. https://github.com/ohmyzsh/ohmyzsh(|.git)) found=1; break ;;
  464. git@github.com:ohmyzsh/ohmyzsh(|.git)) found=1; break ;;
  465. esac
  466. done
  467. (( $found )) || {
  468. _omz::log error "could not found the ohmyzsh git remote. Aborting..."
  469. return 1
  470. }
  471. # Fetch pull request head
  472. _omz::log info "fetching PR #$1 to ohmyzsh/pull-$1..."
  473. command git fetch -f "$remote" refs/pull/$1/head:ohmyzsh/pull-$1 || {
  474. _omz::log error "error when trying to fetch PR #$1."
  475. return 1
  476. }
  477. # Rebase pull request branch against the current master
  478. _omz::log info "rebasing PR #$1..."
  479. local ret gpgsign
  480. {
  481. # Back up commit.gpgsign setting: use --local to get the current repository
  482. # setting, not the global one. If --local is not a known option, it will
  483. # exit with a 129 status code.
  484. gpgsign=$(command git config --local commit.gpgsign 2>/dev/null) || ret=$?
  485. [[ $ret -ne 129 ]] || gpgsign=$(command git config commit.gpgsign 2>/dev/null)
  486. command git config commit.gpgsign false
  487. command git rebase master ohmyzsh/pull-$1 || {
  488. command git rebase --abort &>/dev/null
  489. _omz::log warn "could not rebase PR #$1 on top of master."
  490. _omz::log warn "you might not see the latest stable changes."
  491. _omz::log info "run \`zsh\` to test the changes."
  492. return 1
  493. }
  494. } always {
  495. case "$gpgsign" in
  496. "") command git config --unset commit.gpgsign ;;
  497. *) command git config commit.gpgsign "$gpgsign" ;;
  498. esac
  499. }
  500. _omz::log info "fetch of PR #${1} successful."
  501. )
  502. # If there was an error, abort running zsh to test the PR
  503. [[ $? -eq 0 ]] || return 1
  504. # Run zsh to test the changes
  505. _omz::log info "running \`zsh\` to test the changes. Run \`exit\` to go back."
  506. command zsh -l
  507. # After testing, go back to the previous HEAD if the user wants
  508. _omz::confirm "do you want to go back to the previous branch? [Y/n] "
  509. # Only proceed if the answer is a valid yes option
  510. [[ "$REPLY" != [yY$'\n'] ]] && return
  511. (
  512. set -e
  513. builtin cd -q "$ZSH"
  514. command git checkout "$branch" -- || {
  515. _omz::log error "could not go back to the previous branch ('$branch')."
  516. return 1
  517. }
  518. )
  519. }
  520. function _omz::reload {
  521. # Delete current completion cache
  522. command rm -f $_comp_dumpfile $ZSH_COMPDUMP
  523. # Old zsh versions don't have ZSH_ARGZERO
  524. local zsh="${ZSH_ARGZERO:-${functrace[-1]%:*}}"
  525. # Check whether to run a login shell
  526. [[ "$zsh" = -* || -o login ]] && exec -l "${zsh#-}" || exec "$zsh"
  527. }
  528. function _omz::theme {
  529. (( $# > 0 && $+functions[$0::$1] )) || {
  530. cat >&2 <<EOF
  531. Usage: ${(j: :)${(s.::.)0#_}} <command> [options]
  532. Available commands:
  533. list List all available Oh My Zsh themes
  534. set <theme> Set a theme in your .zshrc file
  535. use <theme> Load a theme
  536. EOF
  537. return 1
  538. }
  539. local command="$1"
  540. shift
  541. $0::$command "$@"
  542. }
  543. function _omz::theme::list {
  544. local -a custom_themes builtin_themes
  545. custom_themes=("$ZSH_CUSTOM"/**/*.zsh-theme(-.N:r:gs:"$ZSH_CUSTOM"/themes/:::gs:"$ZSH_CUSTOM"/:::))
  546. builtin_themes=("$ZSH"/themes/*.zsh-theme(-.N:t:r))
  547. # If the command is being piped, print all found line by line
  548. if [[ ! -t 1 ]]; then
  549. print -l ${(q-)custom_themes} ${(q-)builtin_themes}
  550. return
  551. fi
  552. # Print theme in use
  553. if [[ -n "$ZSH_THEME" ]]; then
  554. print -Pn "%U%BCurrent theme%b%u: "
  555. [[ $ZSH_THEME = random ]] && echo "$RANDOM_THEME (via random)" || echo "$ZSH_THEME"
  556. echo
  557. fi
  558. # Print custom themes if there are any
  559. if (( ${#custom_themes} )); then
  560. print -P "%U%BCustom themes%b%u:"
  561. print -lac ${(q-)custom_themes}
  562. echo
  563. fi
  564. # Print built-in themes
  565. print -P "%U%BBuilt-in themes%b%u:"
  566. print -lac ${(q-)builtin_themes}
  567. }
  568. function _omz::theme::set {
  569. if [[ -z "$1" ]]; then
  570. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <theme>"
  571. return 1
  572. fi
  573. # Check that theme exists
  574. if [[ ! -f "$ZSH_CUSTOM/$1.zsh-theme" ]] \
  575. && [[ ! -f "$ZSH_CUSTOM/themes/$1.zsh-theme" ]] \
  576. && [[ ! -f "$ZSH/themes/$1.zsh-theme" ]]; then
  577. _omz::log error "%B$1%b theme not found"
  578. return 1
  579. fi
  580. # Enable theme in .zshrc
  581. local awk_script='
  582. !set && /^[ \t]*ZSH_THEME=[^#]+.*$/ {
  583. set=1
  584. sub(/^[ \t]*ZSH_THEME=[^#]+.*$/, "ZSH_THEME=\"'$1'\" # set by `omz`")
  585. print $0
  586. next
  587. }
  588. { print $0 }
  589. END {
  590. # If no ZSH_THEME= line was found, return an error
  591. if (!set) exit 1
  592. }
  593. '
  594. local zdot="${ZDOTDIR:-$HOME}"
  595. local zshrc="${${:-"${zdot}/.zshrc"}:A}"
  596. awk "$awk_script" "$zshrc" > "$zdot/.zshrc.new" \
  597. || {
  598. # Prepend ZSH_THEME= line to .zshrc if it doesn't exist
  599. cat <<EOF
  600. ZSH_THEME="$1" # set by \`omz\`
  601. EOF
  602. cat "$zdot/.zshrc"
  603. } > "$zdot/.zshrc.new" \
  604. && command cp -f "$zshrc" "$zdot/.zshrc.bck" \
  605. && command mv -f "$zdot/.zshrc.new" "$zshrc"
  606. # Exit if the new .zshrc file wasn't created correctly
  607. [[ $? -eq 0 ]] || {
  608. local ret=$?
  609. _omz::log error "error setting theme."
  610. return $ret
  611. }
  612. # Exit if the new .zshrc file has syntax errors
  613. if ! command zsh -n "$zdot/.zshrc"; then
  614. _omz::log error "broken syntax in '"${zdot/#$HOME/\~}/.zshrc"'. Rolling back changes..."
  615. command mv -f "$zdot/.zshrc.bck" "$zshrc"
  616. return 1
  617. fi
  618. # Restart the zsh session if there were no errors
  619. _omz::log info "'$1' theme set correctly."
  620. # Only reload zsh if run in an interactive session
  621. [[ ! -o interactive ]] || _omz::reload
  622. }
  623. function _omz::theme::use {
  624. if [[ -z "$1" ]]; then
  625. echo >&2 "Usage: ${(j: :)${(s.::.)0#_}} <theme>"
  626. return 1
  627. fi
  628. # Respect compatibility with old lookup order
  629. if [[ -f "$ZSH_CUSTOM/$1.zsh-theme" ]]; then
  630. source "$ZSH_CUSTOM/$1.zsh-theme"
  631. elif [[ -f "$ZSH_CUSTOM/themes/$1.zsh-theme" ]]; then
  632. source "$ZSH_CUSTOM/themes/$1.zsh-theme"
  633. elif [[ -f "$ZSH/themes/$1.zsh-theme" ]]; then
  634. source "$ZSH/themes/$1.zsh-theme"
  635. else
  636. _omz::log error "%B$1%b theme not found"
  637. return 1
  638. fi
  639. # Update theme settings
  640. ZSH_THEME="$1"
  641. [[ $1 = random ]] || unset RANDOM_THEME
  642. }
  643. function _omz::update {
  644. # Check if git command is available
  645. (( $+commands[git] )) || {
  646. _omz::log error "git is not installed. Aborting..."
  647. return 1
  648. }
  649. local last_commit=$(builtin cd -q "$ZSH"; git rev-parse HEAD 2>/dev/null)
  650. [[ $? -eq 0 ]] || {
  651. _omz::log error "\`$ZSH\` is not a git directory. Aborting..."
  652. return 1
  653. }
  654. # Run update script
  655. zstyle -s ':omz:update' verbose verbose_mode || verbose_mode=default
  656. if [[ "$1" != --unattended ]]; then
  657. ZSH="$ZSH" command zsh -f "$ZSH/tools/upgrade.sh" -i -v $verbose_mode || return $?
  658. else
  659. ZSH="$ZSH" command zsh -f "$ZSH/tools/upgrade.sh" -v $verbose_mode || return $?
  660. fi
  661. # Update last updated file
  662. zmodload zsh/datetime
  663. echo "LAST_EPOCH=$(( EPOCHSECONDS / 60 / 60 / 24 ))" >! "${ZSH_CACHE_DIR}/.zsh-update"
  664. # Remove update lock if it exists
  665. command rm -rf "$ZSH/log/update.lock"
  666. # Restart the zsh session if there were changes
  667. if [[ "$1" != --unattended && "$(builtin cd -q "$ZSH"; git rev-parse HEAD)" != "$last_commit" ]]; then
  668. # Old zsh versions don't have ZSH_ARGZERO
  669. local zsh="${ZSH_ARGZERO:-${functrace[-1]%:*}}"
  670. # Check whether to run a login shell
  671. [[ "$zsh" = -* || -o login ]] && exec -l "${zsh#-}" || exec "$zsh"
  672. fi
  673. }
  674. function _omz::version {
  675. (
  676. builtin cd -q "$ZSH"
  677. # Get the version name:
  678. # 1) try tag-like version
  679. # 2) try branch name
  680. # 3) try name-rev (tag~<rev> or branch~<rev>)
  681. local version
  682. version=$(command git describe --tags HEAD 2>/dev/null) \
  683. || version=$(command git symbolic-ref --quiet --short HEAD 2>/dev/null) \
  684. || version=$(command git name-rev --no-undefined --name-only --exclude="remotes/*" HEAD 2>/dev/null) \
  685. || version="<detached>"
  686. # Get short hash for the current HEAD
  687. local commit=$(command git rev-parse --short HEAD 2>/dev/null)
  688. # Show version and commit hash
  689. printf "%s (%s)\n" "$version" "$commit"
  690. )
  691. }